<template>
  <div class="airportInfo scroll-y">
    <div class="wrap">
      <Minheader
        :is-auth="true"
        :is-statuser="true"
        powerData="new_airport_companies_button"
        @addForm="addForm"
      >
        <template #header>
          <div class="status flex-wrap">
            <div class="manageTitle">机场公司维护</div>
          </div>
        </template></Minheader
      >
      <div class="app-containers">
        <DataTable
          :tableHeader="tableCols"
          :tableData="tableData"
          :tableBtnGroup="tableBtnGroup"
          :tableProperty="{ rowKey: 'ID' }"
          @btnClick="btnClick"
        />
      </div>
      <Dialog
        :flag="flag"
        :type="type"
        :msgTitle="msgTitle"
        :delName="tableForm.companyName"
        @resetForm="resetForm"
        @delRest="delRest"
        @submitForm="submitForm"
        @delRemove="delRemove"
      >
        <div class="diacont">
          <el-form
            :model="tableForm"
            :rules="formRules"
            ref="airportCompanyForm"
          >
            <el-row :gutter="24">
              <el-col>
                <el-form-item
                  label="公司名称"
                  size="default"
                  :rules="formRules.isNotNull"
                  prop="companyName"
                >
                  <el-input
                    v-model="tableForm.companyName"
                    placeholder="请输入公司名称"
                  />
                </el-form-item>
              </el-col>
              <el-col>
                <el-form-item label="上级公司" size="default">
                  <el-select
                    style="width: 100%"
                    v-model="tableForm.parentID"
                    class="input-shadow"
                    filterable
                    default-first-option
                    clearable
                    placeholder="请选择"
                  >
                    <el-option
                      v-for="item in tableOptionser"
                      :key="item.v"
                      :label="item.k"
                      :value="item.v"
                    >
                    </el-option>
                  </el-select>
                </el-form-item>
              </el-col>
              <el-col>
                <el-form-item label="公司描述" size="default">
                  <el-input
                    type="textarea"
                    v-model="tableForm.companyDesc"
                    placeholder="请输入公司描述"
                  />
                </el-form-item>
              </el-col>
            </el-row>
          </el-form>
        </div>
      </Dialog>
    </div>
  </div>
</template>
<script setup lang="ts">
import DataTable from "@/components/tableTemp/index.vue";
import Minheader from "@/components/minheader/index.vue";
import Dialog from "@/components/dialog/index.vue";
import { Query, GeneralDataReception } from "@/api/webApi";
import * as _ from "lodash";
import { ElMessage } from "element-plus";
const power = ref<String>("new_airlines_button"); //权限
const formRules = useElement().formRules;
const page = ref<number>(0); //分页参数
const dataContent = ref<object>({});
const noMore = ref<Boolean>(false);
const asShow = ref<Boolean>(false);
const rowTitle = ref<String>("");
const tableCols = ref([]); //表头数据
const serviceId = ref<String>("");
const tableObj = ref({}); //增删改数据缓存
const flag = ref<Boolean>(false); //弹窗开关
const type = ref<String>(""); //判断是否删除
const msgTitle = ref<String>("新增机场公司维护"); //弹窗标题
const tableOptionser = ref([]); //弹窗下拉
const tableOptionCopys = ref([]); //弹窗下拉
const tableColsCopys = reactive([]); //弹窗
const tableForm = reactive({
  companyName: "",
  parentID: "",
  companyDesc: "",
  companyID: "",
  event: "",
}); //弹窗内容
const tableBtnGroup = ref([
  {
    name: "编辑",
    className: "editBtn",
    param: 2,
    is: "airport_company_editor_button",
  },
  {
    name: "删除",
    className: "delBtn",
    param: 3,
    is: "airport_company_deletion_button",
  },
]);
//列表
const tableData = ref([]);
//表头
const state = reactive({
  list: [
    { label: "公司名称", key: "name" },
    { label: "公司描述", key: "china" },
    { label: "上级公司", key: "englin" },
  ],
  listLoading: true,
});
//新增
const addForm = () => {
  msgTitle.value = "新增机场公司维护";
  flag.value = true;
  type.value = "";
  tableForm.event = 1;
  asShow.value = false;
  asShow.value = true;
};
//取消
const resetForm = () => {
  flag.value = false;
  tableForm.companyName = "";
  tableForm.parentID = "";
  tableForm.companyDesc = "";
  tableForm.companyID = "";
};
//编辑-删除
const btnClick = (row, index, param) => {
  if (param === 2) {
    msgTitle.value = "编辑机场公司维护";
    flag.value = true;
    type.value = "";
    tableForm.event = 2;
    tableForm.companyName = index.companyName;
    tableForm.parentID = index.parentID;
    tableForm.companyDesc = index.companyDesc;
    tableForm.companyID = index.companyID;
    tableOptionser.value = [];
    tableOptionCopys.value.forEach((element) => {
      if (element.k !== index.companyName) {
        tableOptionser.value.push(element);
      }
    });
  } else if (param === 3) {
    msgTitle.value = "删除机场公司维护";
    flag.value = true;
    type.value = "del";
    tableForm.event = 3;
    tableForm.companyName = index.companyName;
    tableForm.parentID = index.parentID;
    tableForm.companyDesc = index.companyDesc;
    tableForm.companyID = index.companyID;
  } else if (param === 4) {
  }
};
//删除
const delRest = () => {
  flag.value = false;
};
//获取弹框-下拉数据
const getSelectData = async (id, name) => {
  const { code, returnData } = await Query({
    id,
    dataContent: name ? [name] : name === null ? [null] : [],
  });
  if (code == 0) {
    tableOptionser.value = returnData.listValues;
    tableOptionCopys.value = _.cloneDeep(returnData.listValues);
  } else {
    tableOptionser.value = [];
  }
};
//获取表格数据
const getQuery = async () => {
  try {
    const { code, returnData } = await Query({
      id: DATACONTENT_ID.airportTreeId,
      needPage: ++page.value,
      dataContent: Object.values(dataContent.value),
    });
    if (code === "0") {
      if (returnData.listValues.length === 0) {
        page.value--;
        noMore.value = true;
      }
      const titleColumn = returnData.columnSet.find(
        (item) => item.needShow === 1
      );
      if (titleColumn) {
        rowTitle.value = titleColumn.columnName;
      }
      tableData.value.push(...returnData.listValues);
      tableCols.value = returnData.columnSet;
      returnData.columnSet.forEach((item) => {
        if (item.listqueryTemplateID && item.columnName === "parentID") {
          getSelectData(item.listqueryTemplateID);
        }
      });
      tableCols.value.forEach((element) => {
        element.label = element.columnLabel;
        element.key = element.columnName;
      });
      serviceId.value = returnData.submitID;
    } else {
      page.value--;
    }
  } catch (error) {
    page.value--;
  }
};
const changeSelect = (data, name) => {
  if (tableForm[data].value === "") {
    tableForm[data].value = null;
  }
};
const resetTable = () => {
  page.value = 0;
  noMore.value = false;
  tableData.value = [];
};
//新增-编辑-删除
const generalDataReception = async (data) => {
  try {
    data = {
      ...data,
    };
    const { code } = await GeneralDataReception({
      serviceId: serviceId.value,
      dataContent: JSON.stringify(data),
    });
    if (code == 0) {
      ElMessage.success(`操作成功`);
      // this.$message.success("操作成功");
      resetTable();
      getQuery();
      resetForm();
      flag.value = false;
      // rmFlag.value = false;
      tableObj.value = {};
      // this.$router.go(0);
    } else {
      ElMessage.error(`操作失败`);
      // this.$message.error("操作失败");
      // this.flag = false;
      // this.rmFlag = false;
      tableObj.value = {};
      resetForm();
    }
  } catch (error) {
    flag.value = false;
    //  rmFlag.value = false;
    tableObj.value = {};
    resetForm();
  }
};
//确认提交
const airportCompanyForm: any = ref(null);
const submitForm = () => {
  airportCompanyForm.value.validate((valid: any) => {
    if (valid) {
      generalDataReception(tableForm);
    } else {
      return false;
    }
  });
};
const delRemove = () => {
  tableForm.event = 3;
  generalDataReception(tableForm);
};
getQuery();
</script>
<style lang="scss" scoped>
::v-deep .el-form-item__label {
  width: 100px;
}
</style>
